/*
  hypercruise.c - Use the cruise engine as a mini jump hole.

  Jason Hood, 12 July, 2010 (ripped out of FL Hack).

  Install:
    copy to EXE and add an entry to [Libraries] in EXE\dacom.ini.

  Requires and assumes v1.1 of common.dll.
*/

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#define NAKED	__declspec(naked)
#define STDCALL __stdcall


#define ADDR_ENGINE    (LPVOID)0x4d6039
#define ADDR_CRUISEMSG (LPVOID)0x5d7fd6
#define ADDR_POSN      (LPVOID)0x63514cb


DWORD dummy;
#define ProtectX( addr, size ) \
  VirtualProtect( addr, size, PAGE_EXECUTE_READWRITE, &dummy );
#define ProtectW( addr, size ) \
  VirtualProtect( addr, size, PAGE_READWRITE, &dummy );

#define RELOFS( from, to ) \
  *(PDWORD)((DWORD)(from)) = (DWORD)(to) - (DWORD)(from) - 4;

#define CALL( from, to ) \
  *(PBYTE)(from) = 0xE8; \
  RELOFS( (DWORD)(from)+1, to )


void test_cruise();
void test_hyper();


void Patch( void )
{
  ProtectX( ADDR_ENGINE,    5 );
  ProtectW( ADDR_CRUISEMSG, 4 );
  ProtectX( ADDR_POSN,	    5 );

  CALL( ADDR_ENGINE, test_cruise );
  CALL( ADDR_POSN,   test_hyper );
}


BOOL WINAPI DllMain( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved )
{
  if (fdwReason == DLL_PROCESS_ATTACH)
    Patch();

  return TRUE;
}
